%See start_callback of batchTrack_gui.m for more!

for i=1:length(filelist)
    t=1;
    attempt=1;
    disp(['Processing frame ' num2str(i) ' of ' num2str(length(filelist))]);
    file=filelist{i};
    done=0;
    while ~done %loop until you have a proper set for xcl and ycl
        try
            [xclOrig,yclOrig]=mainProcess2(file,0,clow,chigh,threshold(t));    %run automated search for spline
            

            if i==1 && ~exist('inBatchMode') %on the first iteration, let the user check the computer
                fig=figure;
                imshow(imread(file));
                hold on
                plot(xclOrig,480-yclOrig+1,'c.');
                plot(xclOrig(1),480-yclOrig(1)+1,'cx','MarkerSize',12);
                hold off
                choice = questdlg('Swap?','Initial Head Recognition','Keep','Swap','Keep');
                switch choice
                    case 'Keep'
                    case 'Swap'
                        [xclOrig,yclOrig]=mainProcess2(file,1,clow,chigh,threshold(t));
                end
                delete(fig)
            end
            
            %compensate for the state movement to find the true path of the
            %worm
            [xcl,ycl]=compensateForStage(xclOrig,yclOrig,i,stageMovement,frameRate,calibx,caliby);

            
            
            l=wormLength(xcl,ycl);
            if i~=1
                if ptDist(xcl(1),ycl(1),lastHeadX,lastHeadY)>ptDist(xcl(end),ycl(end),lastHeadX,lastHeadY)
                    fprintf('\n\nSwapping head with tail\n')
                    [xclOrig,yclOrig]=mainProcess2(file,1,clow,chigh,threshold(t)); %if distance between head and tail is too large, swap.
                    [xcl,ycl]=compensateForStage(xclOrig,yclOrig,i,stageMovement,frameRate,calibx,caliby);
                    disp('Swapped head and tail')
                end
            end

            
            
            lastHeadX=xcl(1);lastHeadY=ycl(1);  %store the last head position for the next iteration of the loop
            done=1; %if it works in the try-catch loop, you're done.
            fprintf('Successfully produced spline\n\n\n');
            
        catch
            disp('Analysis failed--Trying again')
            disp(['Attempt: ' num2str(attempt)])
            attempt=attempt+1;
            if attempt>2 && attempt <=4
                t=2;    
                %t is the variable that describes which multiplier of threshold to use, typically 0.9, then 1.1, then 0.8, then 1.2.
            elseif attempt>4 && attempt <=6
                t=3;
            elseif attempt>6 && attempt <=8
                t=4;
            elseif attempt>8 && attempt <=10
                t=5;
            elseif attempt>10   %skip if 10 attempts fail
                xcl=zeros(1,13);	%come back later to do these manually
                ycl=zeros(1,13);
                xclOrig=xcl;
                yclOrig=ycl;
                done=1;
                manual=1;
                fprintf('\n\n');
            end
        end
        
        if exist('xcl')
        xcl=xcl*calibx;
        ycl=ycl*caliby;
        splineData(2*i-1:2*i,:)=[xcl;ycl];
        splineDataOrig(2*i-1:2*i,:)=[xclOrig;yclOrig];
        end

%         xclOrig=xclOrig*calibx;
%         yclOrig=yclOrig*caliby;       %Why did I comment this out before?????

%At this point xclOrig/yclOrig are in pixels, while xcl/ycl are in
%micrometers

%Must make sure all further operations respect this convention:
%Orig means uncompensated and uncalibrated
%unsuffixed means compensated and calibrated


%         figure(trk)
%         plot(splineData(1:2:2*i-1),splineData(2:2:2*i),'x-')
    end
end
