%This function will find the sum of all eleven bends in a worm recording.
%It repeats this for every time point in the entire recording, and finds
%the average of all of the sums.  This gives some indication of whether
%there may be a difference in bending behavior between groups of worms.


function [sumOfBends]=averageSumOfBends(filename,framesToAnalyze)
[x,y]=plotWormPath(filename,1:13);

if ~strcmp(framesToAnalyze,'all')
    x=x(framesToAnalyze(1):framesToAnalyze(2),:);
    y=y(framesToAnalyze(1):framesToAnalyze(2),:);
end
close(gcf)
bend=[];
for i=1:length(x(:,1));
    bends=wormBends2(x(i,:),y(i,:),2:12);
    bend=[bend;bends];
end

ang=[];
for i=1:length(bend(:,1))
    ang=[ang sum(abs(bend(i,:)))];
end
sumOfBends=mean(ang);