function varargout = batchSpline_gui(varargin)
% BATCHSPLINE_GUI MATLAB code for batchSpline_gui.fig
%      BATCHSPLINE_GUI, by itself, creates a new BATCHSPLINE_GUI or raises the existing
%      singleton*.
%
%      H = BATCHSPLINE_GUI returns the handle to a new BATCHSPLINE_GUI or the handle to
%      the existing singleton*.
%
%      BATCHSPLINE_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BATCHSPLINE_GUI.M with the given input arguments.
%
%      BATCHSPLINE_GUI('Property','Value',...) creates a new BATCHSPLINE_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before batchSpline_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to batchSpline_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help batchSpline_gui

% Last Modified by GUIDE v2.5 24-Nov-2012 22:06:53

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @batchSpline_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @batchSpline_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before batchSpline_gui is made visible.
function batchSpline_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to batchSpline_gui (see VARARGIN)

% Choose default command line output for batchSpline_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes batchSpline_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = batchSpline_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in folderlist.
function folderlist_Callback(hObject, eventdata, handles)
% hObject    handle to folderlist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns folderlist contents as cell array
%        contents{get(hObject,'Value')} returns selected item from folderlist


% --- Executes during object creation, after setting all properties.
function folderlist_CreateFcn(hObject, eventdata, handles)
% hObject    handle to folderlist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in analyze.
function analyze_Callback(hObject, eventdata, handles)
% hObject    handle to analyze (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Compile list of files and thresholds
folderList=get(handles.folderlist,'String');
folders=[]; thresholds=[]; framerates=[];
% frames=[];

inBatchMode=1;

for i=1:length(folderList);
    [f,t,fr]=ftfr(folderList{i});
%     [f,t]=strtok(folderList(i),' T~ '); t=t{1}(4:end);  
%     [t,fr]=strtok(t,' FR~ '); fr=str2double(fr(6:end));
%     t=str2double(t);
    folders=[folders;f];
    thresholds=[thresholds;t];
    framerates=[framerates;fr];
end
disp('Folders:');disp(folders);
disp('Thresholds:');disp(thresholds);
disp('Framerates:');disp(framerates);

calibration=get(handles.calibration,'String');
[calibx,caliby]=strtok(calibration);
calibx=str2double(calibx);
caliby=str2double(caliby);

filelist={};
for z=1:length(folders)
    filelist2=dir([folders{z} '\*.bmp']);
    for j=1:length(filelist2)
        filelist=[filelist;{[folders{z} '\' filelist2(j).name]}];
    end
    slashes=findstr(folders{z},'\'); lastSlash=slashes(end); name=folders{z}(lastSlash+1:end);
    stagepath=[folders{z},'\',name,'.txt'];
    stageMovement=load(stagepath);
    threshold=thresholds(z);
    frameRate=framerates(z);
    clow=0;chigh=1;
    threshold=[threshold .9*threshold 1.1*threshold .8*threshold 1.2*threshold];
    analysisLoop    %produces output of splineData, the splines which have compensated for stage movement,
                    %and splineDataOrig, which is uncompensated
    
    %Now you have to save everything from this set
    savePath=[folders{z} '\batchProduced_splineData.txt'];
    savePathOrig=[folders{z} '\batchProduced_splineData_orig.txt'];
    labels=[{'%%Head'} {'%%Node 2'} {'%%3'} {'%%4'} {'%%5'} {'%%6'} {'%%7'} {'%%8'} {'%%9'} {'%%10'} {'%%11'} {'%%12'} {'%%Tail'}];
    saveDataMatrix(labels,splineData,savePath);
    saveDataMatrix(labels,splineDataOrig,savePathOrig);
    
    disp(['Successfully saved data to ' folders{z}]); fprintf('\n\n\n')
    
    filelist={};
    
end

function [xcl,ycl]=compensateForStage(xcl,ycl,frameNumber,stageMovement,frameRate,calibx,caliby)
%xcl, ycl are row vectors;

rowNum=floor((frameNumber+1)/frameRate)+1;
xStageMovement=stageMovement(:,1);
yStageMovement=stageMovement(:,2);
xMove=sum(xStageMovement(1:rowNum))/calibx; %compensation is done here in pixels!
yMove=sum(yStageMovement(1:rowNum))/caliby;
xcl=xcl+xMove;
ycl=ycl+yMove;

% --- Executes on button press in add.
function add_Callback(hObject, eventdata, handles)
% hObject    handle to add (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try
    [path,threshold,framerate]=folderSelectWindow;
    if threshold<100 && threshold>9
        threshold=['0' num2str(threshold)];
    elseif threshold <10
        threshold=['00' num2str(threshold)];
    else
        threshold=num2str(threshold);
    end
    summaryString=[path,' T~ ',threshold,' FR~ ',framerate];
    folderList=get(handles.folderlist,'String');
    if strcmp('Populate with the ''Add Recording'' button',folderList)
        set(handles.folderlist,'String','')
        folderList='';
    end
    folderList=[folderList;{summaryString}];
    set(handles.folderlist,'String',folderList);
catch
    
end
% --- Executes on button press in remove.
function remove_Callback(hObject, eventdata, handles)
% hObject    handle to remove (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
folderList=get(handles.folderlist,'String');
recNum=inputdlg('Select Recording Number','Remove Recording');
recNum=str2double(recNum);
newFolderList=[folderList(1:recNum-1);folderList(recNum+1:end)];
set(handles.folderlist,'String',newFolderList);



function calibration_Callback(hObject, eventdata, handles)
% hObject    handle to calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of calibration as text
%        str2double(get(hObject,'String')) returns contents of calibration as a double


% --- Executes during object creation, after setting all properties.
function calibration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function [f,t,fr]=ftfr(inputString)
tLoc = strfind(inputString,'T~');
frLoc = strfind(inputString,'FR~');
f=inputString(1:tLoc-2);
t=inputString(tLoc+3:frLoc-2);
fr=inputString(frLoc+4:end);
f={f}; t=str2double(t); fr=str2double(fr);
