function varargout = batchTrack_gui(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @batchTrack_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @batchTrack_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


function batchTrack_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);



function varargout = batchTrack_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

%----------------------PRIMARY ANALYSIS FUNCTION---------------------------

function start_Callback(hObject, eventdata, handles)
imagePath=get(handles.imagePath,'String');  %path where images are stored
filelist=get(handles.imagePath,'UserData'); %list of every image file
frameMatrix=get(handles.frame,'UserData');  %matrix of [1 2 3 4 5;6 7 ....etc]
splineData=zeros(2*length(filelist),13);    %splineData is what will eventually be exported.
splineDataOrig=zeros(2*length(filelist),13);
stageMovement=get(handles.stagePath,'UserData');    %x-y coordinates of stage movement each second
% clow=str2double(get(handles.clow,'String'));
% chigh=str2double(get(handles.chigh,'String'));
clow=0;chigh=1;
calibx=str2double(get(handles.calibx,'String'));
caliby=str2double(get(handles.caliby,'String'));
frameRate=str2double(get(handles.frameRate,'String'));
threshold=str2double(get(handles.threshold,'String'));
threshold=[threshold .9*threshold 1.1*threshold .8*threshold 1.2*threshold];    %a list of thresholds to scan through
% trk=figure;

%ANALYSIS LOOP
%Please check the analysisLoop.m file for specifics; this is the most
%important part of the program!!
%
analysisLoop
%
%
%

set(handles.text16,'UserData',splineDataOrig);
set(handles.splinePath,'UserData',splineData);

disp('Done Analyzing Frames')
topRow=str2double(get(handles.topRow,'String'));
displaySplines

for win=['A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J']
    eval(['set(handles.swap' win ',''Enable'',''on'')']);
    eval(['set(handles.manual' win ',''Enable'',''on'')']);
end

%--------------------END PRIMARY ANALYSIS FUNCTION-------------------------

% function [xcl,ycl]=compensateForStage(xcl,ycl,frameNumber,stageMovement,frameRate,calibx,caliby)
% %xcl, ycl are row vectors;
% rowNum=floor((frameNumber-1)/frameRate)+1;    %rowNum tells you the most recent stage movement row number.
% xStageMovement=stageMovement(:,1);
% yStageMovement=stageMovement(:,2);
% xMove=sum(xStageMovement(1:rowNum))/calibx; %this is the movement of the stage in PIXELS not MICRONS!
% yMove=sum(yStageMovement(1:rowNum))/caliby;
% xcl=xcl+xMove;  %EVERYTHING SHOULD BE IN PIXELS
% ycl=ycl+yMove;

function [xcl,ycl]=compensateForStage(xcl,ycl,frameNumber,stageMovement,frameRate,calibx,caliby)
%xcl, ycl are row vectors;

rowNum=floor((frameNumber+1)/frameRate)+1;
xStageMovement=stageMovement(:,1);
yStageMovement=stageMovement(:,2);
xMove=sum(xStageMovement(1:rowNum))/calibx; %calibration is done here in pixels!
yMove=sum(yStageMovement(1:rowNum))/caliby;
xcl=xcl+xMove;
ycl=ycl+yMove;



function load_Callback(hObject, eventdata, handles)
stagePath=get(handles.stagePath,'String');
imagePath=get(handles.imagePath,'String');
set(handles.text16,'UserData',[]);
set(handles.splinePath,'UserData',[]);
%load the data file
stageMovement=load(stagePath);
set(handles.stagePath,'UserData',stageMovement);

%load the spline filelist
filelist=listBmpsInFolder(imagePath);
set(handles.imagePath,'UserData',filelist);
frameNum=length(filelist);
m=ceil(frameNum/5);
frameMatrix=zeros(5,m);
frameMatrix(1:frameNum)=1:frameNum;
frameMatrix=frameMatrix';
set(handles.frame,'UserData',frameMatrix);
updateFrames(handles,1);
set(handles.pageUp,'Enable','off')
set(handles.pageDown,'Enable','on')
set(handles.topRow,'String','1')

for win=['A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J']
    eval(['set(handles.swap' win ',''Enable'',''off'')']);
    eval(['set(handles.manual' win ',''Enable'',''off'')']);
end

function pageUp_Callback(hObject, eventdata, handles)
frameMatrix=get(handles.frame,'UserData');
l=length(frameMatrix(:,1));
topRow=str2double(get(handles.topRow,'String'));
topRow=topRow-1;
set(handles.topRow,'String',num2str(topRow));
if topRow==l-2
    set(handles.pageDown,'Enable','on')
elseif topRow==1
    set(handles.pageUp,'Enable','off')
end
updateFrames(handles,topRow);


function pageDown_Callback(hObject, eventdata, handles)
frameMatrix=get(handles.frame,'UserData');
l=length(frameMatrix(:,1));
topRow=str2double(get(handles.topRow,'String'));
topRow=topRow+1;
set(handles.topRow,'String',num2str(topRow));
if topRow==l-1
    set(handles.pageDown,'Enable','off')
elseif topRow==2
    set(handles.pageUp,'Enable','on')
end
updateFrames(handles,topRow);

function updateFrames(handles,topRow)
imagePath=get(handles.imagePath,'String');
filelist=get(handles.imagePath,'UserData');
frameMatrix=get(handles.frame,'UserData');
framesToDisplay=frameMatrix(topRow:topRow+1,:);


axes(handles.winA)
showFrame(filelist,framesToDisplay(1,1));
set(handles.frameA,'String',num2str(framesToDisplay(1,1)));
axes(handles.winB)
showFrame(filelist,framesToDisplay(1,2));
set(handles.frameB,'String',num2str(framesToDisplay(1,2)));
axes(handles.winC)
showFrame(filelist,framesToDisplay(1,3));
set(handles.frameC,'String',num2str(framesToDisplay(1,3)));
axes(handles.winD)
showFrame(filelist,framesToDisplay(1,4));
set(handles.frameD,'String',num2str(framesToDisplay(1,4)));
axes(handles.winE)
showFrame(filelist,framesToDisplay(1,5));
set(handles.frameE,'String',num2str(framesToDisplay(1,5)));
axes(handles.winF)
showFrame(filelist,framesToDisplay(2,1));
set(handles.frameF,'String',num2str(framesToDisplay(2,1)));
axes(handles.winG)
showFrame(filelist,framesToDisplay(2,2));
set(handles.frameG,'String',num2str(framesToDisplay(2,2)));
axes(handles.winH)
showFrame(filelist,framesToDisplay(2,3));
set(handles.frameH,'String',num2str(framesToDisplay(2,3)));
axes(handles.winI)
showFrame(filelist,framesToDisplay(2,4));
set(handles.frameI,'String',num2str(framesToDisplay(2,4)));
axes(handles.winJ)
showFrame(filelist,framesToDisplay(2,5));
set(handles.frameJ,'String',num2str(framesToDisplay(2,5)));


splineDataOrig=get(handles.text16,'UserData');
if ~isempty(splineDataOrig)
    displaySplines
end

function showFrame(filelist,frameNum)
if frameNum~=0
    img=imread(filelist{frameNum});
    imshow(img)
else
    c=get(gca,'children');
    delete(c)
    set(gca,'Color',[.831 .816 .784]);
end

function filelist=listBmpsInFolder(path)
%this function will make a cell array of the Bmp files in a folder.
list=dir([path '\*.Bmp']);
filelist=[];
for i=1:length(list)
    filelist=[filelist; {[path '\' list(i).name]}];
end


function save_Callback(hObject, eventdata, handles)
splineData=get(handles.splinePath,'UserData');
savePath=get(handles.splinePath,'String');
labels=[{'%%Head'} {'%%Node 2'} {'%%3'} {'%%4'} {'%%5'} {'%%6'} {'%%7'} {'%%8'} {'%%9'} {'%%10'} {'%%11'} {'%%12'} {'%%Tail'}];
saveDataMatrix(labels,splineData,savePath);

splineDataOrig=get(handles.text16,'UserData');
savePath=[savePath(1:end-4) '_orig.txt'];
labels=[{'%%Head'} {'%%Node 2'} {'%%3'} {'%%4'} {'%%5'} {'%%6'} {'%%7'} {'%%8'} {'%%9'} {'%%10'} {'%%11'} {'%%12'} {'%%Tail'}];
saveDataMatrix(labels,splineDataOrig,savePath);
disp('Changes have been saved');

function swapA_Callback(hObject, eventdata, handles)
f='A';
swapScript


function manualA_Callback(hObject, eventdata, handles)
f='A';
manualScript

function swapB_Callback(hObject, eventdata, handles)
f='B';
swapScript

function manualB_Callback(hObject, eventdata, handles)
f='B';
manualScript

function swapC_Callback(hObject, eventdata, handles)
f='C';
swapScript

function manualC_Callback(hObject, eventdata, handles)
f='C';
manualScript

function swapD_Callback(hObject, eventdata, handles)
f='D';
swapScript

function manualD_Callback(hObject, eventdata, handles)
f='D';
manualScript

function swapE_Callback(hObject, eventdata, handles)
f='E';
swapScript

function manualE_Callback(hObject, eventdata, handles)
f='E';
manualScript

function swapF_Callback(hObject, eventdata, handles)
f='F';
swapScript

function manualF_Callback(hObject, eventdata, handles)
f='F';
manualScript

function swapG_Callback(hObject, eventdata, handles)
f='G';
swapScript

function manualG_Callback(hObject, eventdata, handles)
f='G';
manualScript

function swapH_Callback(hObject, eventdata, handles)
f='H';
swapScript

function manualH_Callback(hObject, eventdata, handles)
f='H';
manualScript

function swapI_Callback(hObject, eventdata, handles)
f='I';
swapScript

function manualI_Callback(hObject, eventdata, handles)
f='I';
manualScript

function swapJ_Callback(hObject, eventdata, handles)
f='J';
swapScript

function manualJ_Callback(hObject, eventdata, handles)
f='J';
manualScript

function browseStage_Callback(hObject, eventdata, handles)
[filename pathname]=uigetfile('*.txt','Open Stage File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.stagePath,'String',[pathname filename]);
end

function browseImage_Callback(hObject, eventdata, handles)
pathname=uigetdir();
if ~isnumeric(pathname)
    set(handles.imagePath,'String',pathname)
    lastSlash=find(pathname=='\');
    lastSlash=lastSlash(end);
    stageName=[pathname '\' pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
    splineName=[pathname '_spline.txt'];
    set(handles.splinePath,'String',splineName)
    
    input_splineData_path=[pathname '\batchProduced_splineData.txt'];
    input_splineData_orig_path=[pathname '\batchProduced_splineData_orig.txt'];
    set(handles.input_splinePath,'String',input_splineData_path);
    set(handles.input_splinePath_orig,'String',input_splineData_orig_path);

end

function imagePath_Callback(hObject, eventdata, handles)

function imagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function stagePath_Callback(hObject, eventdata, handles)

function stagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function input_splinePath_Callback(hObject, eventdata, handles)

function input_splinePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function splinePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function browseInputSpline_Callback(hObject, eventdata, handles)
[filename pathname]=uigetfile('*.txt','Open Spline File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.input_splinePath,'String',[pathname filename]);
end

function threshold_Callback(hObject, eventdata, handles)

function threshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function frameRate_Callback(hObject, eventdata, handles)

function frameRate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function calibx_Callback(hObject, eventdata, handles)

function calibx_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function caliby_Callback(hObject, eventdata, handles)

function caliby_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on imagePath and none of its controls.
function imagePath_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to imagePath (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
if strcmp(eventdata.Key,'return')
    pause(.5)
    flashBox(handles.stagePath,handles.input_splinePath,handles.input_splinePath_orig,handles.splinePath);
    pathname=get(handles.imagePath,'String');
    lastSlash=find(pathname=='\');
    lastSlash=lastSlash(end);
    stageName=[pathname '\' pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
    splineName=[pathname '_spline.txt'];
    set(handles.splinePath,'String',splineName)
    
    input_splineData_path=[pathname '\batchProduced_splineData.txt'];
    input_splineData_orig_path=[pathname '\batchProduced_splineData_orig.txt'];
    set(handles.input_splinePath,'String',input_splineData_path);
    set(handles.input_splinePath_orig,'String',input_splineData_orig_path);
end


% --- Executes on button press in loadSpline.
function loadSpline_Callback(hObject, eventdata, handles)
% hObject    handle to loadSpline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

splinePath=get(handles.input_splinePath,'String');
splinePath_orig=get(handles.input_splinePath_orig,'String');

splineData=load(splinePath);
splineData_orig=load(splinePath_orig);

set(handles.splinePath,'UserData',splineData);
set(handles.text16,'UserData',splineData_orig);

disp('Loaded previously produced spline data');
updateFrames(handles,1);

for win=['A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J']
    eval(['set(handles.swap' win ',''Enable'',''on'')']);
    eval(['set(handles.manual' win ',''Enable'',''on'')']);
end

function input_splinePath_orig_Callback(hObject, eventdata, handles)
% hObject    handle to input_splinePath_orig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of input_splinePath_orig as text
%        str2double(get(hObject,'String')) returns contents of input_splinePath_orig as a double


% --- Executes during object creation, after setting all properties.
function input_splinePath_orig_CreateFcn(hObject, eventdata, handles)
% hObject    handle to input_splinePath_orig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in browseInputSpline_orig.
function browseInputSpline_orig_Callback(hObject, eventdata, handles)
% hObject    handle to browseInputSpline_orig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename pathname]=uigetfile('*.txt','Open Spline (Orig) File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.input_splinePath_orig,'String',[pathname filename]);
end


% --- Executes on button press in browseSpline.
function browseSpline_Callback(hObject, eventdata, handles)
% hObject    handle to browseSpline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename pathname]=uiputfile('*.txt','Open Stage File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.splinePath,'String',[pathname filename]);
end
