function varargout = manualSpline_gui(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @manualSpline_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @manualSpline_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
gui_State.gui_Callback=[];
% End initialization code - DO NOT EDIT

function manualSpline_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

file=varargin{1};
img=imread(file);
img=img(1:end,1:end,1);
axes(handles.win);
h=imshow(img);
set(handles.start,'UserData',h);

set(handles.win,'UserData',varargin{1});
set(handles.adjust,'UserData',varargin{2}); %this should be the last head data

uiwait



function varargout = manualSpline_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;
delete(gcf)

function start_Callback(hObject, eventdata, handles)
file=get(handles.win,'UserData');
img=imread(file);
img=img(1:end,1:end,1);
% axes(handles.win);
% h=imshow(img);
h=get(handles.start,'UserData');

ht=length(img(:,1));
hold on

disp('Click points on the figure to create spline, in head-to-tail order.')

set(h,'buttondownfcn',{@click})
set(handles.done,'UserData',0);
f=1;
while f
    if get(handles.done,'UserData')==1
        f=0;
    end
    pause(.1)
end
splinePoints=get(h,'UserData');
x=splinePoints(:,1);
y=splinePoints(:,2);
xi=interp(x,4);   %interpolate to get a proper spline curve
yi=interp(y,4);
xi=xi(1:end-3);
yi=yi(1:end-3);
x=xi;
y=yi;
hold off
imshow(img) %clear the points
hold on
[xs,ys]=divideSpline(x,y,12);
plot(xs,ys,'.c','MarkerSize',6)
plot(xs(1),ys(1),'xc','MarkerSize',12,'LineWidth',2)

xcl=xs'; ycl=ys'; ycl=ht-ycl+1; %I really need to pick a coordinate system and keep it consistent...
hold off
handles.output=[xcl;ycl];
guidata(hObject,handles);
uiresume

function done_Callback(hObject, eventdata, handles)
set(hObject,'UserData',1)


function click(gcbo,hObject)
data=get(gcbo,'UserData');
p=get(gca,'CurrentPoint');
p=p(1,1:2);
plot(p(1),p(2),'.','MarkerSize',12,'Color','r');
data=[data;p];
set(gcbo,'UserData',data); %store some userdata in the image temporarily



function threshold_Callback(hObject, eventdata, handles)

function threshold_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function adjust_Callback(hObject, eventdata, handles)
file=get(handles.win,'UserData');
threshold=str2double(get(handles.threshold,'String'));
lastHead=get(handles.adjust,'UserData'); lastHeadX=lastHead(1); lastHeadY=lastHead(2);
axes(handles.win);
img=prepImage(file,0,1,threshold);
imshow(img)

attempt=1;
done=0;
while ~done
    try
        [xcl,ycl]=mainProcess2(file,0,0,1,threshold);    %run automated search for spline
        done=1; %if it works in the try-catch loop, you're done.
        
        if ptDist(xcl(1),ycl(1),lastHeadX,lastHeadY)>ptDist(xcl(end),ycl(end),lastHeadX,lastHeadY)
            [xcl,ycl]=mainProcess2(file,1,0,1,threshold); %if distance between head and tail is too large, swap.
            disp('swapped head and tail')
        end


    catch
        if attempt<4
            disp('Analysis failed--Trying again')
            disp(['Attempt: ' num2str(attempt)]);
            attempt=attempt+1;
        else
            disp('Analysis failed--Try a different threshold')
            done=1;
        end
    end
end

if exist('xcl')
    hold on
    plot(xcl,480-ycl+1,'c.');
    plot(xcl(1),480-ycl(1)+1,'cx','MarkerSize',12);
    hold off
    choice = questdlg('Swap?','Initial Head Recognition','Keep','Swap','Keep');
    switch choice
        case 'Keep'
        case 'Swap'
            [xcl,ycl]=mainProcess2(file,1,0,1,threshold);
            hold on
            plot(xcl,480-ycl+1,'c.');
            plot(xcl(1),480-ycl(1)+1,'cx','MarkerSize',12);
            hold off
    end
    
else
    xcl=[0 0 0 0 0 0 0 0 0 0 0 0 0];
    ycl=[0 0 0 0 0 0 0 0 0 0 0 0 0];
    disp('Error fitting spline; please try again');
end
handles.output=[xcl;ycl];
guidata(hObject,handles);
uiresume
