function varargout = playback_gui(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @playback_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @playback_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function playback_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);

function varargout = playback_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

function pause_Callback(hObject, eventdata, handles)
set(hObject,'UserData',1);

function play_Callback(hObject, eventdata, handles)
set(handles.pause,'UserData',0)
f=get(handles.currFrame,'UserData');
frameRate=str2double(get(handles.frameRate,'String'));
filelist=get(handles.load,'UserData');
totalFrames=length(filelist);
while f<=totalFrames && ~get(handles.pause,'UserData')
    showFrame(f,handles);
    f=f+1;
    pause(1/frameRate);
end

function nextFrame_Callback(hObject, eventdata, handles)
f=get(handles.currFrame,'UserData');
try
    f=f+1;
    showFrame(f,handles);
catch
end

function prevFrame_Callback(hObject, eventdata, handles)
f=get(handles.currFrame,'UserData');
try
    f=f-1;
    showFrame(f,handles);
catch
end

function frameRate_Callback(hObject, eventdata, handles)

function frameRate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function path_Callback(hObject, eventdata, handles)

function path_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function browse_Callback(hObject, eventdata, handles)
pathname=uigetdir();
if ~isnumeric(pathname)
    set(handles.path,'String',pathname)
    lastSlash=find(pathname=='\');
    lastSlash=lastSlash(end);
    stageName=[pathname '\' pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
end

function load_Callback(hObject, eventdata, handles)
path=get(handles.path,'String');
filelist=listBmpsInFolder(path);
% filelist=filelist(21:5:end);
totalFiles=length(filelist);
set(handles.load,'UserData',filelist);
set(handles.frameInfo,'String',num2str(totalFiles));
showFrame(1,handles);

function filelist=listBmpsInFolder(path)
list=dir([path '\*.bmp']);
filelist=[];
for i=1:length(list)
    filelist=[filelist; {[path '\' list(i).name]}];
end

function showFrame(number,handles)

% persistent frames;

filelist=get(handles.load,'UserData');
disp(filelist{number});
origfile=[get(handles.path,'string') '_spline_orig.txt'];

showSpline=get(handles.showSpline,'value');
if showSpline
    try
        % splinelist=load('E:\recordings 7-7-10\inx18-5_spline_orig.txt');
        splinelist=load(origfile);
        did=1;
    catch
        did=0;
    end
else
    did=0;
end

if get(handles.showThresholdImage,'Value')
    threshold=str2double(get(handles.threshold,'String'));
    img=prepImage(filelist{number},0,1,threshold);
else
    img=imread(filelist{number});
    img=img(1:end,1:end,1);
end
axes(handles.win)

% tempFig=figure;

imshow(img)

if did==1
    hold on
    plot(splinelist(2*number-1,:),480-splinelist(2*number,:)+1,'c.');
    hold off
    xlim([1 640]);
    ylim([1 480]);
    disp(splinelist(2*number-1,1))
    disp(splinelist(2*number,1))
end

% tempstr=['im' num2str(number) '.tif']

set(handles.currFrame,'String',num2str(number));
% set(handles.frameInfo,'String',[num2str(number) ' / ' num2str(totalFiles)]);
set(handles.currFrame,'UserData',number);


function currFrame_Callback(hObject, eventdata, handles)

function currFrame_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function jumpToFrame_Callback(hObject, eventdata, handles)
frame=str2double(get(handles.currFrame,'String'));
showFrame(frame,handles);


function showThresholdImage_Callback(hObject, eventdata, handles)


function threshold_Callback(hObject, eventdata, handles)

function threshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function f1_Callback(hObject, eventdata, handles)

function f1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function f2_Callback(hObject, eventdata, handles)

function f2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function cut_Callback(hObject, eventdata, handles)
filelist=get(handles.load,'UserData');
f1=str2double(get(handles.f1,'String'));
f2=str2double(get(handles.f2,'String'));
path=get(handles.path,'String');
mkdir([path '\removed']);
stagePath=get(handles.stagePath,'String');
stageMovement=load(stagePath);
copyfile(stagePath,[stagePath(1:end-4) '_orig.txt']);
frameRate=str2double(get(handles.frameRate,'String'));
if f1~=1  %this needs to be fixed to be true for all frame rates... too lazy to do it now.
    linesToRemove=(f1-frameRate-1)/frameRate;    
    newStageMovement=stageMovement([1 linesToRemove+2:end],:);
elseif f1==1
    newStageMovement=[0 0;stageMovement];
    msgbox(['If data was recorded prior to 6-23-10, an incompatibility may'...
        ' exist in which the first 2 seconds of data do not contain valid'...
        ' positional data.  Bending analysis remains valid.  To avoid this'...
        ' issue in data taken prior to 6-23-10, cut the recording from frames 2*fs+1'...
        ' or after--i.e. if fs=15, cut from frame 31 and after.'],'Warning');
end
labels=[{'%%delta-x'} {'%%delta-y'}];
saveDataMatrix(labels,newStageMovement,stagePath);

if f1~=1
    for i=1:f1-1
        movefile(filelist{i},[path '\removed'])
    end
end

if f2~=length(filelist)
    for i=f2+1:length(filelist)
        movefile(filelist{i},[path '\removed'])
    end
end

disp('Cutting Done')

function stagePath_Callback(hObject, eventdata, handles)

function stagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function browseStagePath_Callback(hObject, eventdata, handles)
[filename pathname]=uigetfile('*.txt','Open Stage File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.stagePath,'String',[pathname filename]);
end


function path_KeyPressFcn(gcbo, eventdata, handles)

if strcmp(eventdata.Key,'return')
    pause(.5)
    flashBox(handles.stagePath);
    pathname=get(handles.path,'String');
    lastSlash=find(pathname=='\');
    lastSlash=lastSlash(end);
    stageName=[pathname '\' pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
end


function reduceFrameRate_Callback(hObject, eventdata, handles)
pathname=get(handles.path,'String');
cutFrames_gui(pathname)


% --- Executes on button press in showSpline.
function showSpline_Callback(hObject, eventdata, handles)
% hObject    handle to showSpline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showSpline
